function $(selector) {
    switch (selector.charAt(0)) {
        default: {
            if (selector == "window") {
                return window;
            } else if (selector == "body") {
                return document.body;
            } else if (selector == "html") {
                return document.getElementsByTagName("html")[0];
            } else {
                return document.getElementsByTagName(selector);
            }
        }
        break;
        case "#":
            {
                var elementId = selector.substr(1, selector.length);
                return document.getElementById(elementId);
            }
        case ".":
            {
                var elementsArray = new Array();
                try {
                    var elementClassName = selector.substr(1, selector.length);
                    var elements = document.getElementsByClassName(elementClassName);
                    if (elements != null &&
                        elements.length > 0) {
                        for (var elementIndex = 0; elementIndex < elements.length; elementIndex++) {
                            elementsArray.push(elements[elementIndex]);
                        }
                    }
                } catch (e) {}
                return elementsArray;
            }
    }
    return null;
}
/// String 对象扩展
String.prototype.left = function(nLCount) {
    return this.substring(0, nLCount);
};
String.prototype.right = function(nRCount) {
    return this.substring(this.length - nRCount, this.length);
};
String.prototype.mid = function(nStartI, nEndI) {
    return this.substring(nStartI, nEndI + 1);
};
String.prototype.replaceAll = function(objectWords, newWords) {
    return this.replace(new RegExp(objectWords, "gm"), newWords);

    //return this.replace(new RegExp("['"+strKey+"']","g"),strValue);
}
String.prototype.countOfChar = function(ch) {
    var count;
    var c, i;
    count = 0;
    c = this.length;
    for (i = 0; i < c; i++) {
        if (this.charAt(i) == ch) {
            count++;
        }
    }
    return count;
}
String.prototype.trim = function() {
    return this.replace(/(^\s*)|(\s*$)/g, "");
}

var kGSApp_URLParams = new Array();
var GSAppKeyValue = function(key, value) {
    this.key = key;
    this.value = value;
};

function gsAppLoadURLParams() {
    var url = document.location.href;
    if (typeof(url) != "string") {
        return;
    }
    var indexOfQuestionMarkInURL = url.indexOf("?");
    if (indexOfQuestionMarkInURL < 0) {
        return;
    }

    var urlParamsOriginTextBeginIndex = indexOfQuestionMarkInURL + 1;
    var urlParamsOriginText = url.substr(urlParamsOriginTextBeginIndex,
        url.length - urlParamsOriginTextBeginIndex);
    if (urlParamsOriginText.length < 1) {
        return;
    }

    var urlParams = urlParamsOriginText.split("&");
    if (urlParams.length < 1) {
        return;
    }
    urlParams.forEach(
        function(urlParam) {
            var urlParamInfes = urlParam.split("=");
            var urlParamKeyValue = new GSAppKeyValue(urlParamInfes[0], urlParamInfes[1]);
            // !!!
            kGSApp_URLParams.push(urlParamKeyValue);
            // !!!
        }
    );
}
gsAppLoadURLParams();

function gsAppValueOfURLParam(paramName) {
    var paramValue = "";
    kGSApp_URLParams.some(
        function(urlParam) {
            if (urlParam.key == paramName) {
                if (typeof(urlParam.value) == "string") {
                    paramValue = urlParam.value;
                }
                return true;
            }
            return false;
        }
    );
    return paramValue;
}

function gsAppSendRequest(request) {
    var a = document.createElement("a"); {
        a.href = request;
    }
    a.click();
}

function gsAppOpenContentWithContentType(contentType, content, otherParams) {
    if (!content) {
        content = "";
    }
    if (!otherParams) {
        otherParams = "";
    }

    var requestURL = "";
    if (content instanceof Array) {
        var contentParam = "";

        content.forEach(function(item) {
            if (contentParam.length < 1) {
                contentParam = "[";
            } else {
                contentParam += ", ";
            }

            if (typeof(item) == "string") {
                contentParam += "\"" + item.tostring() + "\"";
            } else {
                contentParam += item.tostring();
            }
        });

        contentParam += "]";
        content = contentParam;
    }


    requestURL
        = "gsapp://open.gsapp.com?request={" +
        "\"contentType\":\"" + contentType + "\"" +
        ", \"content\":\"" + content + "\"" +
        otherParams +
        "}";

    gsAppSendRequest(requestURL);
}

function gsAppOpenURL(url) {
    gsAppOpenContentWithContentType("url", url);
}

function gsAppOpenOperate(operate) {
	gsAppOpenContentWithContentType("operate", operate);
}

function gsGetObjectPositionInDocument(target) {
    var targetPosition = function() {
        this.x = 0;
        this.y = 0;
    };
    try {
        targetPosition.x = target.offsetLeft;
        targetPosition.y = target.offsetTop;

        for (var parent = target.parentNode; parent != document.body; parent = parent.parentNode) {
            targetPosition.x += parent.offsetLeft;
            targetPosition.y += parent.offsetTop;
        }
    } catch (e) {}
    return targetPosition;
}

function gsGetObjectPositionInClient(target) {
    var targetPositionInDocument = gsGetObjectPositionInDocument(target); {
        targetPositionInDocument.x -= document.body.scrollLeft;
        targetPositionInDocument.y -= document.body.scrollTop;
    }
    return targetPositionInDocument;
}
